#define KEY_CHAR_0 71
#define KEY_CHAR_1 72
#define KEY_CHAR_2 62
#define KEY_CHAR_3 52
#define KEY_CHAR_4 73
#define KEY_CHAR_5 63
#define KEY_CHAR_6 53
#define KEY_CHAR_7 74
#define KEY_CHAR_8 64
#define KEY_CHAR_9 54
#define KEY_CHAR_DP 61
#define KEY_CHAR_EXP 51
#define KEY_CHAR_PMINUS 41
#define KEY_CHAR_PLUS 42
#define KEY_CHAR_MINUS 32
#define KEY_CHAR_MULT 43
#define KEY_CHAR_DIV 33
#define KEY_CHAR_FRAC 75
#define KEY_CHAR_LPAR 55
#define KEY_CHAR_RPAR 45
#define KEY_CHAR_COMMA 35
#define KEY_CHAR_STORE 25
#define KEY_CHAR_LOG 66
#define KEY_CHAR_LN 56
#define KEY_CHAR_SIN 46
#define KEY_CHAR_COS 36
#define KEY_CHAR_TAN 26
#define KEY_CHAR_SQUARE 67
#define KEY_CHAR_POW 57
#define KEY_CTRL_EXE 31
#define KEY_CTRL_DEL 44
#define KEY_CTRL_AC 32
#define KEY_CTRL_FD 65
#define KEY_CTRL_EXIT 47
#define KEY_CTRL_SHIFT 78
#define KEY_CTRL_ALPHA 77
#define KEY_CTRL_OPTN 68
#define KEY_CTRL_VARS 58
#define KEY_CTRL_UP 28
#define KEY_CTRL_DOWN 37
#define KEY_CTRL_LEFT 38
#define KEY_CTRL_RIGHT 27
#define KEY_CTRL_F1 79
#define KEY_CTRL_F2 69
#define KEY_CTRL_F3 59
#define KEY_CTRL_F4 49
#define KEY_CTRL_F5 39
#define KEY_CTRL_F6 29
#define KEY_CTRL_MENU 48
#define __KEYBIOS_H__

#include "fxlib.h"
#include "memory.h"
#include "niveaux.h"
#include "MonochromeLib.h"
#include "keys.h"

void quelniveau( int *niveauchoisi, int code )
{
	int gagner = 0;

	switch ( code )
	{
	case 11220:
		*niveauchoisi = 2;
		break;
	case 30123:
		*niveauchoisi = 3;
		break;
	case 31234:
		*niveauchoisi = 4;
		break;
	case 3234:
		*niveauchoisi = 5;
		break;
	case 21122:
		*niveauchoisi = 6;
		break;
	case 21224:
		*niveauchoisi = 7;
		break;
	default:
		*niveauchoisi = 1;
		break;
	}

	do
	{
		gagner = 0;
		gen_niveau( *niveauchoisi, &gagner );

		if( gagner ) (*niveauchoisi)++;

	} while( *niveauchoisi <= 7 || !gagner );

}

void niveaucomplet( int niveauchoisi )
{
	int x;
	int NIVEAUMAX = 7;
	unsigned char perso_droite[] = {0x18, 0x18, 0x33, 0x3E, 0x30, 0x38, 0x68, 0x4C};
	unsigned char gateau[] = {0x08, 0x10, 0x10, 0xFF, 0xFF, 0xAB, 0x81, 0xFF};
	unsigned char piedestal[] = {0xFF, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E};

	for( x = 0; x <= 127; x++ )
	{
		ML_vertical_line( x, 0, 63, 1 );
		ML_display_vram();
		Sleep( 5 );
	}

	Bdisp_AllClr_DDVRAM();
	ML_vertical_line( 29, 0, 63, 1 );
	ML_vertical_line( 38, 0, 63, 1 );
	ML_horizontal_line( 0, 30, 37, 1 );
	ML_horizontal_line( 9, 30, 37, 1 );
	ML_bmp_8_xor( perso_droite, 30, 1 );	
	ML_display_vram();

	for( x = 0; x <= 53; x++ )
	{
		ML_vertical_scroll( 1 );

		if( niveauchoisi == NIVEAUMAX )
		{
			ML_bmp_8_xor( gateau, 50, 47 );
			ML_bmp_8_xor( piedestal, 50, 55 );
		}

		ML_display_vram();

		if( niveauchoisi == NIVEAUMAX )
		{
			ML_bmp_8_xor( gateau, 50, 47 );
			ML_bmp_8_xor( piedestal, 50, 55 );
		}

		Sleep( 30 );
	}

	if( niveauchoisi == NIVEAUMAX )
	{
		ML_bmp_8_xor( gateau, 50, 47 );
		ML_bmp_8_xor( piedestal, 50, 55 );
	}

	if( niveauchoisi < NIVEAUMAX )
	{
		PrintMini( 45, 10, (const unsigned char*)"Salle completee.", MINI_OR );
		PrintMini( 45, 20, (const unsigned char*)"MDP de la salle", MINI_OR );
		PrintMini( 45, 30, (const unsigned char*)"suivante:", MINI_OR );

		switch( niveauchoisi )
		{
		case 1:
			PrintMini( 64, 40, (const unsigned char *) "11220", MINI_OR );
			break;
		case 2:
			PrintMini( 64, 40, (const unsigned char *) "30123", MINI_OR );
			break;
		case 3:
			PrintMini( 64, 40, (const unsigned char *) "31234", MINI_OR );
			break;
		case 4:
			PrintMini( 64, 40, (const unsigned char *) "03234", MINI_OR );
			break;
		case 5:
			PrintMini( 64, 40, (const unsigned char *) "21122", MINI_OR );
			break;
		case 6:
			PrintMini( 64, 40, (const unsigned char *) "21224", MINI_OR );
		}

		ML_display_vram();
	}

	for( x = 62; x > 54; x-- )
	{
		ML_pixel( 38, x, 0 );
		ML_display_vram();
		Sleep( 75 );
	}

	if( niveauchoisi == NIVEAUMAX )
	{
		PrintMini( 40, 50, (const unsigned char*)":D", MINI_OVER );
		ML_display_vram();
		Sleep( 1000 );
		PrintMini( 8, 5, (const unsigned char*)"Here, the cake is not a lie ;)", MINI_OVER );
		ML_display_vram();
	}

	while( IsKeyUp( KEY_CTRL_EXE ) );

	Sleep(1000);
}

void niveauperdu()
{
	int a;

	for( a = 0; a < 64; a++ )
	{
		ML_horizontal_line( a, 0, 127, 1 );
	}

	ML_display_vram();
	Sleep( 200 );
}