#define KEY_CHAR_0 71
#define KEY_CHAR_1 72
#define KEY_CHAR_2 62
#define KEY_CHAR_3 52
#define KEY_CHAR_4 73
#define KEY_CHAR_5 63
#define KEY_CHAR_6 53
#define KEY_CHAR_7 74
#define KEY_CHAR_8 64
#define KEY_CHAR_9 54
#define KEY_CHAR_DP 61
#define KEY_CHAR_EXP 51
#define KEY_CHAR_PMINUS 41
#define KEY_CHAR_PLUS 42
#define KEY_CHAR_MINUS 32
#define KEY_CHAR_MULT 43
#define KEY_CHAR_DIV 33
#define KEY_CHAR_FRAC 75
#define KEY_CHAR_LPAR 55
#define KEY_CHAR_RPAR 45
#define KEY_CHAR_COMMA 35
#define KEY_CHAR_STORE 25
#define KEY_CHAR_LOG 66
#define KEY_CHAR_LN 56
#define KEY_CHAR_SIN 46
#define KEY_CHAR_COS 36
#define KEY_CHAR_TAN 26
#define KEY_CHAR_SQUARE 67
#define KEY_CHAR_POW 57
#define KEY_CTRL_EXE 31
#define KEY_CTRL_DEL 44
#define KEY_CTRL_AC 32
#define KEY_CTRL_FD 65
#define KEY_CTRL_EXIT 47
#define KEY_CTRL_SHIFT 78
#define KEY_CTRL_ALPHA 77
#define KEY_CTRL_OPTN 68
#define KEY_CTRL_VARS 58
#define KEY_CTRL_UP 28
#define KEY_CTRL_DOWN 37
#define KEY_CTRL_LEFT 38
#define KEY_CTRL_RIGHT 27
#define KEY_CTRL_F1 79
#define KEY_CTRL_F2 69
#define KEY_CTRL_F3 59
#define KEY_CTRL_F4 49
#define KEY_CTRL_F5 39
#define KEY_CTRL_F6 29
#define KEY_CTRL_MENU 48
#define __KEYBIOS_H__

#include "stdlib.h"
#include "fxlib.h"
#include "MonochromeLib.h"
#include "niveaux.h"
#include "stddef.h"
#include "keys.h"

void gen_niveau( int niveauchoisi, int *gagner )
{
	unsigned int key;
	int *mat_niveau = NULL;
	int x, y, largeur, hauteur, ecranx, ecrany;
/*dclaration des bmp reprsentant les tiles qui
apparaissent dans les niveaux*/
	unsigned char antiportal[] = {0xFF, 0xE7, 0xF3, 0xDB, 0xDB, 0xCF, 0xE7, 0xFF};
	unsigned char sol[] = {0xFF, 0x99, 0xDB, 0xA5, 0xA5, 0xDB, 0x99, 0xFF};
	unsigned char sortie[] = {0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C};
	unsigned char emancipation[] = {0xE0, 0x0E, 0xE0, 0x0B, 0xD0, 0x07, 0x70, 0x07};
	unsigned char eau[] = {0x04, 0x26, 0xD9, 0x02, 0xA5, 0x30, 0x4B, 0x00};

	Bdisp_AllClr_DDVRAM();

	if( niveauchoisi <= 3 )
	{
		hauteur = 8;
		largeur = 16;
		ecranx = 0;
		ecrany = 0;
	}

	if( niveauchoisi > 3 && niveauchoisi <= 6 )
	{
		hauteur = 8;
		largeur = 32;
		ecranx = 0;
		ecrany = 0;
	}

	if( niveauchoisi == 7 )
	{
		hauteur = 16;
		largeur = 16;
		ecranx = 0;
		ecrany = 1;
	}

	mat_niveau = calloc( hauteur * largeur , sizeof( int ) );

	if(mat_niveau == NULL)
	{
		Bdisp_AllClr_DDVRAM();
		PrintMini( 1, 1, (unsigned char*)"Erreur memoire. Appuyez sur menu", 1 );

		while(1)
		{
        			GetKey(&key);
		}
	}

	matinit( mat_niveau, niveauchoisi);

	for( y = ecrany * 8; y <= largeur * ecrany * 8 + 7; y++ )
	{

		for( x = 0; x <= 15; x++ )
		{

			if( mat_niveau[y * largeur + x] == 1 ) ML_bmp_8_xor( sol, 8 * x, 8 * ( y - 8 * ecrany ) );

			if( mat_niveau [y * largeur + x] == -1 ) ML_bmp_8_xor( sortie, 8 * x, 8 * ( y - 8 * ecrany ) );

			if( mat_niveau [y * largeur + x] == 2 ) ML_bmp_8_xor( antiportal, 8 * x, 8 * ( y - 8 * ecrany ) );

			if( mat_niveau [y * largeur + x] == -3 ) ML_bmp_8_xor( emancipation, 8 * x, 8 * ( y - 8 * ecrany ) );

			if( mat_niveau [y * largeur + x] == -4 ) ML_bmp_8_xor( eau, 8 * x, 8 * ( y - 8 * ecrany ) );
		}

	}

	ML_display_vram(); //affichage des tiles gnrs dans la boucle prcdente
	jouer( mat_niveau, niveauchoisi, largeur, hauteur, ecranx, ecrany, gagner );
}

void matinit( int *mat_niveau, int niveauchoisi )
{
	int x;
	int liste1[128] = {1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
				1,1,1,0,0,0,0,0,-1,1,0,0,0,0,0,1,
	 			1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
				1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
	int liste2[128] = {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
				1,0,0,0,0,0,0,-3,0,0,0,0,0,0,0,1,
				1,0,0,0,0,0,0,-3,-1,0,0,0,0,0,0,1,
				1,0,0,0,0,0,0,-3,2,0,0,0,1,1,1,1,
				1,1,1,1,0,0,0,-3,0,0,0,0,0,0,0,1,
				1,0,0,0,0,0,0,2,2,1,0,0,0,0,0,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
				1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
	int liste3[128] = {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
				2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,
				1,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,2,
				1,0,0,0,0,2,0,0,2,2,2,-3,-3,-3,-3,2,
				1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,2,
				1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,2,
				1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1};
	int liste4[256] = {2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,
				2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,1,
				2,-1,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,
				2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
				2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,1,
				2,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,
				2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,-4,-4,-4,-4,-4,-4,-4,-4,1,0,0,0,1,
				1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,1,1,1,1,-4,1,1,1};

/*	int liste6[256] = {2,2,2,2,2,2,1,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,
				2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,
				2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,
				2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,2,
				2,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,1,0,2,
				2,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,2,
				2,0,0,0,0,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,-1,0,0,2,
				1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}; */

	switch( niveauchoisi )
	{
	case 1:
		for( x = 0; x < 128; x++ )mat_niveau[x] = liste1[x];
		break;
	case 2:
		for( x = 0; x < 128; x++ )mat_niveau[x] = liste2[x];
		break;
	case 3:
		for( x = 0; x < 128; x++ )mat_niveau[x] = liste3[x];
		break;
	case 4:
		for( x = 0; x < 256; x++ )mat_niveau[x] = liste4[x];
		break;
	case 5:
		for( x = 0; x < 32; x++ )
		{
			mat_niveau[x] = 2;
			mat_niveau[32 * 7 + x] = 1;
		}

		mat_niveau[7] = 1;

		for( x = 0; x < 8; x++ )
		{
			mat_niveau[x * 32] = 1;
			mat_niveau[x * 32 +31] = 2;
		}

		mat_niveau[51] = 1;
		mat_niveau[41] = 2;
		mat_niveau[40] = -3;
		mat_niveau[98] = 1;
		mat_niveau[71] = 2;
		mat_niveau[72] = 2;
		mat_niveau[73] = 2;
		mat_niveau[140] = 2;
		mat_niveau[174] = 2;
		mat_niveau[181] = 1;
		mat_niveau[182] = 1;
		mat_niveau[190] = -1;
		mat_niveau[205] = 1;
		for( x = 14; x < 19 ; x++ ) mat_niveau[32 * 4 + x] = 1;
		for( x = 7; x < 11 ; x++ ) mat_niveau[32 * 5 + x] = 2;
		for( x = 28; x < 31; x++ ) mat_niveau[32 * 6 + x] = 2;
		for( x = 4 ; x < 6 ; x++ ) mat_niveau[32 * x +23] = 1;
		for( x = 1; x<7; x++ ) mat_niveau[32 * x + 26] = -3;
		break;
	case 6:
		for( x = 0; x < 32; x++ ) mat_niveau[x] = 2;
		for( x = 224; x < 256; x++ ) mat_niveau[x] = 1;
		for( x = 27; x < 29; x++ ) mat_niveau[x] = 1;
		for( x = 237; x < 240; x++ ) mat_niveau[x] = 2;
		for( x = 1; x < 7; x++ )
		{
			mat_niveau[32 * x] = 1;
			mat_niveau[32 * ( x + 1 ) - 1] = 1;
		}
		for( x = 196; x < 206; x++ ) mat_niveau[x] = -4;
		mat_niveau[200] = 1;
		mat_niveau[206] = 2;
		for( x = 3; x < 7; x++ ) mat_niveau[32 * x + 3] = 1;
		for( x = 146; x < 151; x++ ) mat_niveau[x] = 1;
		for( x = 3; x < 7; x++ ) mat_niveau[32 * x +29] = 2;
		for( x = 212; x < 217; x++ ) mat_niveau[x] = -4;
		mat_niveau[211] = 2;
		mat_niveau[217] = 2;
		mat_niveau[105] = 2;
		mat_niveau[106] = 2;
		mat_niveau[107] = 1;
		for( x = 1; x < 6; x++ ) mat_niveau[32 * x + 14] = -3;
		for( x = 2; x < 5; x++ ) mat_niveau[32 * x + 15] = 1;
		mat_niveau[151] = 1;
		mat_niveau[222] = -1;
		for( x = 1; x < 6; x++ ) mat_niveau[32 * x + 25] = -3;
		mat_niveau[100] = 1;
		mat_niveau[101] = 1;
		break;

	case 7:
		mat_niveau[30] = -1;
		for( x = 0; x < 16; x++ ) mat_niveau[x] = 2;
		for( x = 240; x<256; x++ ) mat_niveau[x] = 1;
		for( x = 0; x < 8; x++ ) mat_niveau[16 * x] = 2;
		for( x = 8; x < 16; x++ ) mat_niveau[16 * x] = 1;
		for( x = 1; x < 16; x++ ) mat_niveau[16 * x +15] = 1;
		for( x = 51; x < 55; x++ ) mat_niveau[x] = 2;
		for( x = 162; x < 165; x++ ) mat_niveau[x] = 1;
		for( x = 123; x < 126; x++ ) mat_niveau[x] = 1;
		for( x = 203; x < 207; x++ )
		{
			mat_niveau[x] = 1;
			mat_niveau[x + 16] = 1;
			mat_niveau[x + 32] = 1;
		}
		for( x = 8; x < 12; x++ ) mat_niveau[x * 16 + 11] = -3;
		for(x = 227; x < 230; x++ ) mat_niveau[x] = 1;
		for( x = 8; x < 11; x++ ) mat_niveau[x * 16] = 2;
		for( x = 8; x < 10; x++ ) mat_niveau[x * 16 + 8] = -3;
		for( x = 43; x < 45; x++ ) mat_niveau[x] = 2;
		mat_niveau[211] = 2;
		mat_niveau[212] = 2;
		mat_niveau[213] = 1;
		mat_niveau[168] = 2;
		mat_niveau[169] = 1;
		mat_niveau[142] = 1;
		mat_niveau[113] = 2;
		mat_niveau[117] = 2;
		mat_niveau[103] = 1;
		mat_niveau[119] = 1;
		mat_niveau[121] = 2;
		mat_niveau[97] = 1;
		mat_niveau[98] = 1;
		mat_niveau[93] = 1;
		mat_niveau[45] = 1;
		mat_niveau[46] = 1;
		mat_niveau[62] = 1;
		mat_niveau[12] = 1;
		mat_niveau[173] = 1;
		break;
	}

}